#include <stdio.h>
#include <math.h>
//#define CLUMP 1000
int CLUMP;
#define INCLUDE 1
int seq[400000], run[400000], qrel[400000], next[400000], prev[400000];
int maxseq;
double sc,score[400000],x[400000];
int i,j,k,m,n,pr,ne; int fp, fn, tp, tn, tfp, tfn, ttp, ttn;
int inversions = 0;
double sumcnt,sumit,nfp,ntp,thistp,thisfp;
FILE *d,*s,*r;
char tmp[1000];
int perm[400000];
int ofp=-1, otp=-1, ofn=-1, otn=-1;

int comp(int *a, int *b){
   if (score[*a] > score[*b]) return -1;
   if (score[*a] < score[*b]) return +1;
   return 0;
}
int comp1(int *a, int *b){
   if (score[*a] > score[*b]) return +1;
   if (score[*a] < score[*b]) return -1;
   return 0;
}

main(int argc, char **argv){
   sprintf(tmp,"%s.roc",argv[1]);
   r = fopen(tmp,"w");
   freopen(argv[1],"r",stdin);
   sprintf(tmp,"%s.txt",argv[1]);
   d = fopen(tmp,"w");
   sprintf(tmp,"%s.spss",argv[1]);
   s = fopen(tmp,"w");
   if (argc > 2) maxseq = atoi(argv[2]);
   fprintf(s,"seq seq10k run qrel err fneg fpos prev next x score\n");
  
   for (n=0;4 == scanf("%d%d%d%lf%*[^\n]",&seq[n],&run[n],&qrel[n],&score[n]);n++);
printf("%d records read\n",n);
   //for (i=0;i<n;i++) if (seq[i] > maxseq) maxseq = seq[i];
   //maxseq = 49086;
CLUMP = (n+49)/50;
   for (i=0;i<n;i++) if (run[i] != 2) run[i] = 1;
   if (!strncmp(argv[1],"crm",3)) {
      for (i=0;i<n;i++) score[i] = -score[i];
   }
   for (i=0;i<n;i++) {
      if (qrel[i] == 1 && run[i] != 2) tn++;
      if (qrel[i] == 1 && run[i] == 2) fp++;
      if (qrel[i] == 2 && run[i] == 2) tp++;
      if (qrel[i] == 2 && run[i] != 2) fn++;
      if (i%10000 == 9999 || i == n-1){
         printf("Sequence %d to %d\n",i-i%10000,i);
         printf("%6d%6d\n%6d%6d\n",tn, fn, fp, tp);
         printf("err: %0.2lf%%\n",100.0*(fn+fp)/(fn+fp+tn+tp));
         printf("fp:  %0.2lf%%\n",100.0*fp/(tn+fp));
         printf("fn:  %0.2lf%%\n",100.0*fn/(fn+tp));
         ttp += tp; ttn += tn; tfp += fp; tfn += fn;
         tp = tn = fp = fn = 0;
         printf("\n");
      }
   }
   printf("Overall\n");
   printf("%8d%8d\n%8d%8d\n",ttn, tfn, tfp, ttp);
   printf("err: %0.2lf%%\n",100.0*(tfn+tfp)/(tfn+tfp+ttn+ttp));
   printf("fp:  %0.2lf%%\n",100.0*tfp/(ttn+tfp));
   printf("fn:  %0.2lf%%\n",100.0*tfn/(ttp+tfn));

   for (i=0;i<n;i++) perm[i] = i;
   qsort(perm,n,sizeof(int),comp);
   //for (i=0;i<n;i++) printf("%0.3lf\n",score[perm[i]]);

   tn = tp = fn = fp = 0; ntp = -7; nfp = -7;
   sc = score[perm[0]];
   for (i=0;;i++) {
      if (i == n || score[perm[i]] != sc) {
         if (tp != otp) {
            if (ofp != -1) {
               //printf("---\n%6d%6d\n%6d%6d\n",otn,ofn,ofp,otp);
               thisfp = log10((double)ofp/otn); 
               if (thisfp == -1.0l/0) thisfp=-7;
               if (thisfp == 1.0l/0) thisfp=7;
               thistp = log10((double)otp/ofn);
               if (thistp == -1.0l/0) thistp=-7;
               if (thistp == 1.0l/0) thistp = 7;
               //printf("%0.6lf %0.6lf %0.6lf %0.6lf\n",thisfp,thistp,nfp,ntp);
               if (thistp > ntp) {
                  if (thisfp > nfp) {
                     if (fabs(nfp) != 7 && fabs(ntp) != 7) fprintf(r,"%0.6lf %0.6lf\n",nfp,ntp);
                     nfp = thisfp;
                  }
                  ntp = thistp;
               }
            }
            ofp = fp; otp = tp; ofn =fn; otn = tn;
         } else {
            
         }
         if (i == n) break;
         sc = score[perm[i]];
      }
      if (qrel[perm[i]] == 1) fp++;
      if (qrel[perm[i]] == 2) tp++;
      tn = ttn + tfp - fp;
      fn = tfn + ttp - tp;
      if (qrel[perm[i]] == 2) inversions += fp;
   }
   if (fabs(nfp) != 7 && fabs(ntp) != 7) fprintf(r,"%0.6lf %0.6lf\n",nfp,ntp);
   if(1){
      int hams, spams, fn, inversions;
      double roca;
      qsort(perm,n,sizeof(int),comp1);
      hams = spams = fn = inversions = 0;
      for (i=0;i<n;i++) {
         if (qrel[perm[i]] == 1) hams++; else spams++;
         if (qrel[perm[i]] == 2) fn++;
         if (qrel[perm[i]] == 1) inversions += fn;
      }
      roca = (double)inversions/((double)hams*spams);
      //printf("roca %lg\n",roca);
      //roca = log(roca/(1-roca));
      printf("roca%%:   %0.3lg\n",100.0*roca);
   }
 

   //printf("inversions: %d\n",inversions);
   //printf("possible: %d\n",(ttn+tfp)*(ttp+tfn));
   //printf("roca%%:   %0.2lg\n",100*(double)inversions/((double)(ttn+tfp)*(ttp+tfn)));
   //printf("\n");

   pr = 0;
   for (i=0;i<n;i++) {
      prev[i] = pr;
      if (qrel[i] != run[i]) pr = i+1;//seq[i];
      //if (qrel[i] == INCLUDE && qrel[i] != run[i]) pr = i+1;//seq[i];
   }
   ne = n+1;
   for (i=n-1;i>=0;i--) {
      next[i] = ne;
      if (qrel[i] != run[i]) ne = i+1;//seq[i];
      //if (qrel[i] == INCLUDE && qrel[i] != run[i]) ne = i+1;//seq[i];
   }
   for (i=0; prev[i] == 0; i++ )
      prev[i] = 1 - (next[0] - 1);
   for (i=n-1; next[i] == n+1; i--)
     next[i] = n + (n - prev[n-1]);
   for (i=0;i<n;i++) {
      x[i] = 1.0L / (next[i] - prev[i]);
      if (qrel[i] != run[i]) x[i] *= 2;
      //if (qrel[i] == INCLUDE && qrel[i] != run[i]) x[i] *= 2;
   }
   for (i=0;i<n;i++) {
      fprintf(s,"%d %0.6lf %d %d %d %d %d %d %d %0.5lf %0.6lf\n",
        seq[i],(double)(seq[i]-maxseq)/10000.0,run[i],qrel[i],
        qrel[i] != run[i], run[i] == 1 && (qrel[i] != run[i]),
        run[i] == 2 && (qrel[i] != run[i]), prev[i], next[i], x[i],
        score[i]);
      //sumit += x[i];
      sumit += run[i] != qrel[i];
      sumcnt++;
      if (i%CLUMP == CLUMP-1 /* || i == n-1 */) {
         if (sumit > 0 || i == n-1) {
            //fprintf(d,"%d %0.6lf\n",seq[i-i%CLUMP/2],log10(sumit/(1+i%CLUMP-sumit)));
            fprintf(d,"%d %0.6lf\n",seq[i-(int)sumcnt/2],log10(sumit/(sumcnt-sumit)));
            sumit = sumcnt = 0;
         }
      }
   }
   fclose(s); fclose(d);
   sprintf(tmp,"sed -e 's/RUNNAME/%s/' adhoc1.plot | gnuplot > %s.ps",argv[1],argv[1]);
   //system(tmp);
}
